<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html">sdkInterfaces</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html">HTTPContentFetcherInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_h_t_t_p_content_fetcher_interface_8h_source.html">HTTPContentFetcherInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_lib_curl_http_content_fetcher.html" title="alexaClientSDK::avsCommon\l::utils::libcurlUtils::\lLibCurlHttpContentFetcher" alt="" coords="307,5,504,57"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1media_player_1_1test_1_1_mock_content_fetcher.html" title="A mock content fetcher. " alt="" coords="308,81,504,120"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1playlist_parser_1_1test_1_1_mock_content_fetcher.html" title="A mock content fetcher. " alt="" coords="295,144,516,183"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface_1_1_header.html">Header</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:aa2dbdbb9bbf0442fff5b43d7baa40190"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aa2dbdbb9bbf0442fff5b43d7baa40190">FetchOptions</a> { <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aa2dbdbb9bbf0442fff5b43d7baa40190a69f4c5323778d9d6383109d492070656">FetchOptions::CONTENT_TYPE</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aa2dbdbb9bbf0442fff5b43d7baa40190a88688062deacd9356286364aef9601f7">FetchOptions::ENTIRE_BODY</a>
 }</td></tr>
<tr class="memdesc:aa2dbdbb9bbf0442fff5b43d7baa40190"><td class="mdescLeft">&#160;</td><td class="mdescRight">Represents what HTTP content to fetch.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aa2dbdbb9bbf0442fff5b43d7baa40190">More...</a><br /></td></tr>
<tr class="separator:aa2dbdbb9bbf0442fff5b43d7baa40190"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba5364b9cdcabdc4dcab1d8a64370b86"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86">State</a> { <br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86adee5f03c2c4e73657824e028494b18c0">State::INITIALIZED</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86aecb032beffdf90ff84b145c0c361313c">State::FETCHING_HEADER</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86ac449178c9953cdc0fe17c4d69f85f7ee">State::HEADER_DONE</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86ac67d580e25dcbffc9a54a12bd74da057">State::FETCHING_BODY</a>, 
<br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86aaab54f5c39f6e9366a4d285f1c689cb2">State::BODY_DONE</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86abb1ca97ec761fc37101737ba0aa2e7c5">State::ERROR</a>
<br />
 }</td></tr>
<tr class="memdesc:aba5364b9cdcabdc4dcab1d8a64370b86"><td class="mdescLeft">&#160;</td><td class="mdescRight">The state of payload fetching.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86">More...</a><br /></td></tr>
<tr class="separator:aba5364b9cdcabdc4dcab1d8a64370b86"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a5c1e66c49c3bf1dbc6ceda042c444793"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#a5c1e66c49c3bf1dbc6ceda042c444793">~HTTPContentFetcherInterface</a> ()=default</td></tr>
<tr class="separator:a5c1e66c49c3bf1dbc6ceda042c444793"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b0dd0688189652c23542e8f1bb0a8e2"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86">State</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#a5b0dd0688189652c23542e8f1bb0a8e2">getState</a> ()=0</td></tr>
<tr class="separator:a5b0dd0688189652c23542e8f1bb0a8e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ade5a7f42801cc9f3c3737a7c5ff1363f"><td class="memItemLeft" align="right" valign="top">virtual std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#ade5a7f42801cc9f3c3737a7c5ff1363f">getUrl</a> () const =0</td></tr>
<tr class="separator:ade5a7f42801cc9f3c3737a7c5ff1363f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a145c122572e43c147d50fc1e5aa74ee3"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface_1_1_header.html">Header</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#a145c122572e43c147d50fc1e5aa74ee3">getHeader</a> (std::atomic&lt; bool &gt; *shouldShutdown)=0</td></tr>
<tr class="separator:a145c122572e43c147d50fc1e5aa74ee3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af05e284931dcb648a0e4a1cb9eb4cd7e"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#af05e284931dcb648a0e4a1cb9eb4cd7e">getBody</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">avsCommon::avs::attachment::AttachmentWriter</a> &gt; writer)=0</td></tr>
<tr class="separator:af05e284931dcb648a0e4a1cb9eb4cd7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8381635579b31e3e99f4432ceb656709"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#a8381635579b31e3e99f4432ceb656709">shutdown</a> ()=0</td></tr>
<tr class="separator:a8381635579b31e3e99f4432ceb656709"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ad46788f5f434b3a79168c4ebbe4eb3"><td class="memItemLeft" align="right" valign="top">virtual std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_h_t_t_p_content.html">avsCommon::utils::HTTPContent</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#a8ad46788f5f434b3a79168c4ebbe4eb3">getContent</a> (<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aa2dbdbb9bbf0442fff5b43d7baa40190">FetchOptions</a> option, std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">avsCommon::avs::attachment::AttachmentWriter</a> &gt; writer=nullptr, const std::vector&lt; std::string &gt; &amp;customHeaders=std::vector&lt; std::string &gt;())=0</td></tr>
<tr class="separator:a8ad46788f5f434b3a79168c4ebbe4eb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ad4fd816761ed2e1d94fd0622ef953ac4"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#ad4fd816761ed2e1d94fd0622ef953ac4">getUserAgent</a> ()</td></tr>
<tr class="separator:ad4fd816761ed2e1d94fd0622ef953ac4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64758ffbfef79b3f000e1dca8b86b1c2"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#a64758ffbfef79b3f000e1dca8b86b1c2">stateToString</a> (<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86">State</a> state)</td></tr>
<tr class="separator:a64758ffbfef79b3f000e1dca8b86b1c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">This class allows users to fetch content from remote location using HTTP(S). </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a id="aa2dbdbb9bbf0442fff5b43d7baa40190"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa2dbdbb9bbf0442fff5b43d7baa40190">&#9670;&nbsp;</a></span>FetchOptions</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aa2dbdbb9bbf0442fff5b43d7baa40190">alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::FetchOptions</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Represents what HTTP content to fetch. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="aa2dbdbb9bbf0442fff5b43d7baa40190a69f4c5323778d9d6383109d492070656"></a>CONTENT_TYPE&#160;</td><td class="fielddoc"><p class="">Retrieves the content type part of the HTTP header. </p>
</td></tr>
<tr><td class="fieldname"><a id="aa2dbdbb9bbf0442fff5b43d7baa40190a88688062deacd9356286364aef9601f7"></a>ENTIRE_BODY&#160;</td><td class="fielddoc"><p class="">Retrieves the entire body of the remote location. </p>
</td></tr>
</table>

</div>
</div>
<a id="aba5364b9cdcabdc4dcab1d8a64370b86"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aba5364b9cdcabdc4dcab1d8a64370b86">&#9670;&nbsp;</a></span>State</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86">alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::State</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The state of payload fetching. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="aba5364b9cdcabdc4dcab1d8a64370b86adee5f03c2c4e73657824e028494b18c0"></a>INITIALIZED&#160;</td><td class="fielddoc"><p class="">Initialized but nothing was downloaded yet. </p>
</td></tr>
<tr><td class="fieldname"><a id="aba5364b9cdcabdc4dcab1d8a64370b86aecb032beffdf90ff84b145c0c361313c"></a>FETCHING_HEADER&#160;</td><td class="fielddoc"><p class="">Currently fetching the header. </p>
</td></tr>
<tr><td class="fieldname"><a id="aba5364b9cdcabdc4dcab1d8a64370b86ac449178c9953cdc0fe17c4d69f85f7ee"></a>HEADER_DONE&#160;</td><td class="fielddoc"><p class="">Done fetching the header. Ready to start fetching the body. </p>
</td></tr>
<tr><td class="fieldname"><a id="aba5364b9cdcabdc4dcab1d8a64370b86ac67d580e25dcbffc9a54a12bd74da057"></a>FETCHING_BODY&#160;</td><td class="fielddoc"><p class="">Currently fetching the body. </p>
</td></tr>
<tr><td class="fieldname"><a id="aba5364b9cdcabdc4dcab1d8a64370b86aaab54f5c39f6e9366a4d285f1c689cb2"></a>BODY_DONE&#160;</td><td class="fielddoc"><p class="">Done fetching the body. At this point the content fetcher can only be used to read the headers. </p>
</td></tr>
<tr><td class="fieldname"><a id="aba5364b9cdcabdc4dcab1d8a64370b86abb1ca97ec761fc37101737ba0aa2e7c5"></a>ERROR&#160;</td><td class="fielddoc"><p class="">Some error happened at any stage and the content fetcher cannot be used anymore. </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a5c1e66c49c3bf1dbc6ceda042c444793"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5c1e66c49c3bf1dbc6ceda042c444793">&#9670;&nbsp;</a></span>~HTTPContentFetcherInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::~HTTPContentFetcherInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="af05e284931dcb648a0e4a1cb9eb4cd7e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af05e284931dcb648a0e4a1cb9eb4cd7e">&#9670;&nbsp;</a></span>getBody()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::getBody </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">avsCommon::avs::attachment::AttachmentWriter</a> &gt;&#160;</td>
          <td class="paramname"><em>writer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Retrieves the body after the header was received. This method is asynchronous and the caller can monitor the download progress using the <code>getState</code> method.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">writer</td><td>The writer to write the payload. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if the call is successful. </dd></dl>

</div>
</div>
<a id="a8ad46788f5f434b3a79168c4ebbe4eb3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8ad46788f5f434b3a79168c4ebbe4eb3">&#9670;&nbsp;</a></span>getContent()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual std::unique_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_h_t_t_p_content.html">avsCommon::utils::HTTPContent</a>&gt; alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::getContent </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aa2dbdbb9bbf0442fff5b43d7baa40190">FetchOptions</a>&#160;</td>
          <td class="paramname"><em>option</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">avsCommon::avs::attachment::AttachmentWriter</a> &gt;&#160;</td>
          <td class="paramname"><em>writer</em> = <code>nullptr</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>customHeaders</em> = <code>std::vector&lt;&#160;std::string&#160;&gt;()</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This function retrieves content from a remote location. No thread safety is guaranteed.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">option</td><td>Flag indicating desired content. </td></tr>
    <tr><td class="paramname">writer</td><td>An optional writer parameter to be used when writing to an external stream. </td></tr>
    <tr><td class="paramname">customHeaders</td><td>An optional list of headers to be attached to the request. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A new <code>HTTPContent</code> object or <code>nullptr</code> if a failure occurred. </dd></dl>

</div>
</div>
<a id="a145c122572e43c147d50fc1e5aa74ee3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a145c122572e43c147d50fc1e5aa74ee3">&#9670;&nbsp;</a></span>getHeader()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface_1_1_header.html">Header</a> alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::getHeader </td>
          <td>(</td>
          <td class="paramtype">std::atomic&lt; bool &gt; *&#160;</td>
          <td class="paramname"><em>shouldShutdown</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Waits until the header was fetched successfully. If any problem happened during header, returns <code>false</code>. After the header was already fetched, this method can be called multiple times and will return immediately.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">shouldShutdown</td><td>A pointer to allow for the caller to asynchronously cancel the wait, if needed. this argument is optional. If it is a null pointer, the function will ignore it. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The header struct. It is the caller's responsibility to check the struct to see if the header was retrieved successfully. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1playlist_parser_1_1test_1_1_mock_content_fetcher.html#aa619de0a800e158bdc3d8c33defa2f38">alexaClientSDK::playlistParser::test::MockContentFetcher</a>, <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1test_1_1_mock_content_fetcher.html#a143365ea67641b0ea447732c050061a0">alexaClientSDK::mediaPlayer::test::MockContentFetcher</a>, and <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_lib_curl_http_content_fetcher.html#a1924f13910f8f8bb896c55b4a3efb3de">alexaClientSDK::avsCommon::utils::libcurlUtils::LibCurlHttpContentFetcher</a>.</p>

</div>
</div>
<a id="a5b0dd0688189652c23542e8f1bb0a8e2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5b0dd0688189652c23542e8f1bb0a8e2">&#9670;&nbsp;</a></span>getState()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86">State</a> alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::getState </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">The current content fetching state. In particular, a caller of <code>getBody</code>, an asynchronous function, can use this method to monitor the download progress.</p>
<dl class="section return"><dt>Returns</dt><dd>The current content fetching state. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1playlist_parser_1_1test_1_1_mock_content_fetcher.html#a2249b8da6ded3d53fdd8f54544b80fe6">alexaClientSDK::playlistParser::test::MockContentFetcher</a>, <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1test_1_1_mock_content_fetcher.html#a0d816f37fb4f7c095fc7440b9808752a">alexaClientSDK::mediaPlayer::test::MockContentFetcher</a>, and <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_lib_curl_http_content_fetcher.html#ad33b53c1d5c409da7cc09eae1e937a5c">alexaClientSDK::avsCommon::utils::libcurlUtils::LibCurlHttpContentFetcher</a>.</p>

</div>
</div>
<a id="ade5a7f42801cc9f3c3737a7c5ff1363f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ade5a7f42801cc9f3c3737a7c5ff1363f">&#9670;&nbsp;</a></span>getUrl()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual std::string alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::getUrl </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Gets the URL associated with this content fetcher</p>
<dl class="section return"><dt>Returns</dt><dd>The content fetcher URL </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1playlist_parser_1_1test_1_1_mock_content_fetcher.html#a657138cd4d94b32225795e0b407c0286">alexaClientSDK::playlistParser::test::MockContentFetcher</a>, <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1test_1_1_mock_content_fetcher.html#acd9a13f45f13ae92f481bc4b6c9ce6ee">alexaClientSDK::mediaPlayer::test::MockContentFetcher</a>, and <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_lib_curl_http_content_fetcher.html#a303700f305bc5954f05ec8bc4c9412d7">alexaClientSDK::avsCommon::utils::libcurlUtils::LibCurlHttpContentFetcher</a>.</p>

</div>
</div>
<a id="ad4fd816761ed2e1d94fd0622ef953ac4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad4fd816761ed2e1d94fd0622ef953ac4">&#9670;&nbsp;</a></span>getUserAgent()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::getUserAgent </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Returns a string that represents the User-Agent to be used in HTTP requests.</p>
<dl class="section return"><dt>Returns</dt><dd>User-Agent string to be used in HTTP requests. </dd></dl>

</div>
</div>
<a id="a8381635579b31e3e99f4432ceb656709"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8381635579b31e3e99f4432ceb656709">&#9670;&nbsp;</a></span>shutdown()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::shutdown </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Shuts down the content fetcher. </p>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1playlist_parser_1_1test_1_1_mock_content_fetcher.html#a7df84f60c055db64446ec935f0fb5a61">alexaClientSDK::playlistParser::test::MockContentFetcher</a>, <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1test_1_1_mock_content_fetcher.html#a076aafe66bc475e2617b21ea860a8d22">alexaClientSDK::mediaPlayer::test::MockContentFetcher</a>, and <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_lib_curl_http_content_fetcher.html#abefb434813491e97fe16424a663e9557">alexaClientSDK::avsCommon::utils::libcurlUtils::LibCurlHttpContentFetcher</a>.</p>

</div>
</div>
<a id="a64758ffbfef79b3f000e1dca8b86b1c2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a64758ffbfef79b3f000e1dca8b86b1c2">&#9670;&nbsp;</a></span>stateToString()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::sdkInterfaces::HTTPContentFetcherInterface::stateToString </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_h_t_t_p_content_fetcher_interface.html#aba5364b9cdcabdc4dcab1d8a64370b86">HTTPContentFetcherInterface::State</a>&#160;</td>
          <td class="paramname"><em>state</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Produces the string representation of the state enum values. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">state</td><td>The state enum value. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Its string representation. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/SDKInterfaces/include/AVSCommon/SDKInterfaces/<a class="el" href="_h_t_t_p_content_fetcher_interface_8h_source.html">HTTPContentFetcherInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
